"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _memoize = _interopRequireDefault(require("lodash/memoize"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiIcons = require("@instructure/ui-icons");

var _uiButtons = require("@instructure/ui-buttons");

var _uiForms = require("@instructure/ui-forms");

var _uiLayout = require("@instructure/ui-layout");

var _uiElements = require("@instructure/ui-elements");

var _uiA11y = require("@instructure/ui-a11y");

var _uiThemeable = require("@instructure/ui-themeable");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _TagSuggestSelect = _interopRequireDefault(require("../../../common/components/shared/TagSuggestSelect"));

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'eyMTa',
  template: function template(theme) {
    return "\n\n.eyMTa_ecuB{padding:".concat(theme.searchInteractionsPaddingTopBottom || 'inherit', " ").concat(theme.searchInteractionsPaddingLeftRight || 'inherit', "}\n\n.eyMTa_eYuC{display:flex;margin-top:1rem}\n\n.eyMTa_czeD{flex:1;margin-right:2rem}");
  },
  'interactionType': 'eyMTa_ecuB',
  'filterContainer': 'eyMTa_eYuC',
  'filterColumn': 'eyMTa_czeD'
};

var tagShape = _propTypes.default.shape({
  tag: _propTypes.default.shape({
    id: _propTypes.default.string,
    value: _propTypes.default.string.isRequired
  }).isRequired,
  count: _propTypes.default.number.isRequired
});

var BankSearch = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(BankSearch, _Component);

  function BankSearch() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BankSearch);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BankSearch)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.toggleInteraction = (0, _memoize.default)(function (it) {
      return function () {
        return _this.props.toggle('interactionTypes', it);
      };
    });

    _this.setTags = function (tags) {
      return _this.props.setFilter('tags', tags);
    };

    _this.updateSearch = function (_ref) {
      var value = _ref.target.value;
      return _this.props.update(value);
    };

    return _this;
  }

  (0, _createClass2.default)(BankSearch, [{
    key: "renderFilters",
    value: function renderFilters() {
      var _this2 = this;

      var _this$props = this.props,
          allInteractions = _this$props.allInteractions,
          search = _this$props.search,
          showFilters = _this$props.showFilters,
          toggleAllInteractions = _this$props.toggleAllInteractions,
          interactionTypes = _this$props.interactionTypes;

      if (showFilters) {
        var its = interactionTypes;
        var shown = allInteractions ? its : its.slice(0, 5);
        var active = search.get('interactionTypes');
        var interactionFilters = shown.map(function (_ref2) {
          var count = _ref2.count,
              it = _ref2.interaction_type;
          var label = "".concat(it.name, " (").concat(count, ")");
          return _react.default.createElement("div", {
            key: it.id,
            className: styles.interactionType
          }, _react.default.createElement(_uiForms.Checkbox, {
            checked: active.has(it.id),
            label: label,
            onChange: _this2.toggleInteraction(it.id),
            value: "medium"
          }));
        });
        var suggestions = this.props.tags.map(function (_ref3) {
          var tag = _ref3.tag;
          return tag;
        });
        var activeTags = this.props.search.get('tags');

        var tagSelect = _react.default.createElement(_TagSuggestSelect.default, {
          noMatchText: (0, _formatMessage.default)('No matching tags found'),
          parentType: "Bank",
          parentId: "0",
          onChange: this.setTags,
          tags: activeTags,
          defaultSuggestions: suggestions
        });

        var toggleButton = function toggleButton() {
          if (shown.length < its.length || allInteractions) {
            var hide = function hide() {
              return (0, _formatMessage.default)('Show Less');
            };

            var show = function show() {
              return (0, _formatMessage.default)('Show More');
            };

            var text = allInteractions ? hide() : show();
            return _react.default.createElement(_uiButtons.Button, {
              onClick: toggleAllInteractions,
              margin: "none small",
              variant: "link"
            }, _react.default.createElement(_uiA11y.AccessibleContent, {
              alt: text
            }, text));
          }
        };

        return _react.default.createElement("div", {
          className: styles.filterContainer
        }, _react.default.createElement("div", {
          className: styles.filterColumn
        }, tagSelect), _react.default.createElement("div", {
          className: styles.filterColumn
        }, _react.default.createElement(_uiLayout.View, {
          margin: "none small"
        }, _react.default.createElement(_uiElements.Text, {
          weight: "bold",
          color: "primary"
        }, (0, _formatMessage.default)('Item Type'))), interactionFilters, toggleButton()));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          showFilters = _this$props2.showFilters,
          toggleFilters = _this$props2.toggleFilters;
      return _react.default.createElement("div", null, _react.default.createElement(_uiLayout.Flex, {
        as: "div"
      }, _react.default.createElement(_uiLayout.Flex.Item, {
        grow: true,
        shrink: true
      }, _react.default.createElement(_uiForms.TextInput, {
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Search')),
        type: "search",
        placeholder: (0, _formatMessage.default)('Search'),
        onChange: this.updateSearch,
        value: this.props.search.get('text', '') || ''
      })), _react.default.createElement(_uiLayout.Flex.Item, null, _react.default.createElement(_uiButtons.Button, {
        onClick: toggleFilters,
        margin: "none none none small",
        icon: _uiIcons.IconPlusLine,
        "data-automation": "sdk-search-filter-button"
      }, _react.default.createElement(_uiA11y.AccessibleContent, {
        alt: showFilters ? (0, _formatMessage.default)('Hide search filters') : (0, _formatMessage.default)('Show search filters')
      }, (0, _formatMessage.default)('Filters'))))), this.renderFilters());
    }
  }]);
  BankSearch.displayName = "BankSearch";
  return BankSearch;
}(_react.Component), _class2.propTypes = {
  allInteractions: _propTypes.default.bool,
  interactionTypes: _propTypes.default.arrayOf(_propTypes.default.shape({
    count: _propTypes.default.number,
    interaction_type: _propTypes.default.shape({
      id: _propTypes.default.string,
      name: _propTypes.default.string
    })
  })),
  showFilters: _propTypes.default.bool,
  tags: _propTypes.default.arrayOf(tagShape),
  toggleFilters: _propTypes.default.func.isRequired,
  toggleAllInteractions: _propTypes.default.func.isRequired,
  search: _reactImmutableProptypes.default.map.isRequired,
  toggle: _propTypes.default.func.isRequired,
  setFilter: _propTypes.default.func.isRequired,
  update: _propTypes.default.func.isRequired
}, _class2.defaultProps = {
  allInteractions: false,
  interactionTypes: [],
  showFilters: false,
  tags: []
}, _temp)) || _class);
exports.default = BankSearch;