"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiMenu = require("@instructure/ui-menu");

var _uiButtons = require("@instructure/ui-buttons");

var _uiIcons = require("@instructure/ui-icons");

var _uiA11y = require("@instructure/ui-a11y");

var _uiThemeable = require("@instructure/ui-themeable");

var _QTIImportModal = _interopRequireDefault(require("../../../building/components/QTIImportModal"));

var _quizCommon = require("@instructure/quiz-common");

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'HITck',
  template: function template(theme) {
    return "\n\n.HITck_cLWx{font-size:".concat(theme.menuIconFontSize || 'inherit', ";margin-right:").concat(theme.menuIconMargin || 'inherit', ";vertical-align:middle}");
  },
  'menuIcon': 'HITck_cLWx'
};
var HeaderMenu = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(HeaderMenu, _Component);

  function HeaderMenu() {
    (0, _classCallCheck2.default)(this, HeaderMenu);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(HeaderMenu).apply(this, arguments));
  }

  (0, _createClass2.default)(HeaderMenu, [{
    key: "renderMenu",
    value: function renderMenu() {
      return _react.default.createElement(_uiMenu.Menu, {
        trigger: _react.default.createElement(_uiButtons.Button, {
          variant: "icon",
          icon: _uiIcons.IconMoreSolid
        }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('More Item Banking Actions')))
      }, _react.default.createElement(_uiMenu.Menu.Item, {
        key: "import",
        disabled: !this.props.bank.canImport(),
        onSelect: this.props.openImportModal
      }, _react.default.createElement(_uiIcons.IconImportLine, {
        className: styles.menuIcon,
        "data-automation": "sdk-headermenu-import-content"
      }), (0, _formatMessage.default)('Import Content')));
    }
  }, {
    key: "render",
    value: function render() {
      var bank = this.props.bank;
      return _react.default.createElement("div", null, this.renderMenu(), _react.default.createElement(_QTIImportModal.default, {
        parentId: bank.id,
        parentType: _quizCommon.PARENT_TYPE_BANK,
        qtiImport: bank.getLatestImport(),
        "data-automation": "sdk-qti-import-modal"
      }));
    }
  }]);
  HeaderMenu.displayName = "HeaderMenu";
  return HeaderMenu;
}(_react.Component), _class2.propTypes = {
  openImportModal: _propTypes.default.func.isRequired,
  bank: _reactImmutableProptypes.default.record.isRequired
}, _temp)) || _class);
exports.default = HeaderMenu;